Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/releases/release-110.63/install.sh
ViewVC logotype

Diff of /config/releases/release-110.63/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 249, Sat Apr 17 18:57:03 1999 UTC sml/trunk/config/install.sh revision 1140, Wed Mar 13 18:59:03 2002 UTC
# Line 2  Line 2 
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4  #  #
5  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
6  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
7  #  #
8    # Significant changes to accommodate (and take advantage of) the new CM
9    # by M.Blume (2/2000).
10    #
11    
12    if [ x${INSTALL_QUIETLY} = xtrue ] ; then
13        export CM_VERBOSE=false
14    fi
15    
16    vsay() {
17        if [ x${INSTALL_DEBUG} = xtrue ] ; then
18            echo "$@"
19        elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
20            :
21        else
22            echo "$@"
23        fi
24    }
25    
26    dsay() {
27        if [ x${INSTALL_DEBUG} = xtrue ] ; then
28            echo "$@"
29        fi
30    }
31    
32    complain() {
33        echo "$@"
34        exit 1
35    }
36    
37    # The following variable holds the name of all possible targets.
38    # The names must occur in the order in which targets are to be built.
39    ALLTARGETS=\
40    "src-smlnj \
41     ml-yacc \
42     ml-lex \
43     ml-burg \
44     ml-nlffigen \
45     smlnj-lib \
46     cml \
47     cml-lib \
48     eXene \
49     ckit \
50     ml-nlffi-lib \
51     pgraph-util \
52     mlrisc-tools \
53     nowhere \
54     doc"
55    
56    this=$0
57    
58    # By default, move libraries to lib directory:
59    MOVE_LIBRARIES=true
60    
61    # function to be used in config/targets:
62    dont_move_libraries() { MOVE_LIBRARIES=false ; }
63    
64  #set -x  # Initialize target list.
65    TARGETS=""
66    
67    # function to be used in config/targets:
68    request() { TARGETS="$TARGETS $1" ; }
69    
70  #  #
71  # get the target list  # get the target list
72  #  #
73  if [ ! -r config/targets ]; then  if [ -r config/targets.customized ] ; then
74    echo "!!! no target list"      . config/targets.customized
75    exit 1;  elif [ ! -r config/targets ]; then
76  fi      complain "$this: !!! File config/targets is missing."
77    else
78  . config/targets  . config/targets
79    fi
80    
81  #  #
82  # some OSs have make in strange places  # resolve dependencies
83  #  #
84  MAKE=make  isnotin() {
85        tested_x=$1
86        shift
87        for set_y in "$@" ; do
88            if [ ${tested_x} = ${set_y} ] ; then
89                return 1
90            fi
91        done
92        return 0
93    }
94    
95    require() {
96        require_who=$1
97        shift
98        if isnotin ${require_who} ${TARGETS} ; then
99            :
100        else
101            for required_x in "$@" ; do
102                if isnotin ${required_x} ${TARGETS} ; then
103                    echo "Including ${required_x} (needed by ${require_who})."
104                    request ${required_x}
105                    CHANGED=true
106                fi
107            done
108        fi
109    }
110    
111    onepass() {
112        while read depline ; do
113            require $depline
114        done
115    }
116    
117    if [ -r config/dependencies ] ; then
118        CHANGED=true
119        while [ $CHANGED = true ]; do
120            CHANGED=false
121            onepass <config/dependencies
122        done
123    fi
124    
125    #
126    # Rebuild target list using the order defined by ALLTARGETS.
127    #
128    NEWTARGETS=""
129    for t in ${ALLTARGETS} ; do
130        if isnotin $t ${TARGETS} ; then
131            :
132        else
133            NEWTARGETS="$NEWTARGETS $t"
134        fi
135    done
136    TARGETS=$NEWTARGETS
137    
138  #  #
139  # command for building SML libraries; this should be either  # create the preloads.standard file
 # "CM.recompile()" or "CM.stabilize true".  The latter builds  
 # stable libraries, which may be somewhat faster to use.  
140  #  #
141  #CM_MAKE_LIB="CM.recompile();"  if [ ! -r config/preloads ]; then
142  CM_MAKE_LIB="CM.stabilize true;"      complain "$this: !!! File config/preloads is missing."
143    fi
144    cp config/preloads preloads.standard
145    
146  #  #
147  # check for ksh  # Some OSs have make in strange places, but most of the time it is
148    # simply on the PATH:
149  #  #
150  # ksh causes some people problems so we will always use /bin/sh  MAKE=make
151    
152  #  #
153  #echo "checking for ksh"  # Make sure we don't have any unpleasant surprises due to the installing
154  #if [ -x /bin/ksh ]; then  # user's process environment:
155  #  SHELL=/bin/ksh  #
156  #elif [ -x /usr/local/bin/ksh ]; then  unset CM_PATHCONFIG
157  #  SHELL=/usr/local/bin/ksh  
 #else  
158    SHELL=/bin/sh    SHELL=/bin/sh
159  #fi  vsay $this: Using shell $SHELL.
 echo "  using $SHELL"  
160    
161  #  #
162  # set the SML root directory  # set the SML root directory
163  #  #
164  REAL_PWD=`pwd`  REAL_PWD=`pwd`
165  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
166  echo "SML root is $ROOT"  vsay $this: SML root is $ROOT.
167    vsay $this: Installation directory is ${INSTALLDIR:=$ROOT}.
168    
169  #  #
170  # set the various directory pathname variables  # set the various directory and file pathname variables
171  #  #
172  BINDIR=$ROOT/bin  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
173  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
174  HEAPDIR=$BINDIR/.heap  HEAPDIR=$BINDIR/.heap           # where heap images live
175  RUNDIR=$BINDIR/.run  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
176  SRCDIR=$ROOT/src  SRCDIR=$ROOT/src                # where the source tree is rooted
177  LIBDIR=$ROOT/lib  LIBDIR=$INSTALLDIR/lib          # where libraries live
178    LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries
179    LATESTANDALONES=$ROOT/latestandalones # standalone programs to be built late
180    LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
181    LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
182    
183  #  #
184  # the paths to ml-yacc and ml-lex; needed to configure CM  # The path to the dir where ml-yacc, ml-burg, ml-lex, ml-build, and
185    # ml-makedepend live.  This path will be interpreted relative to $LIBDIR.
186  #  #
187  YACCPATH=$BINDIR/ml-yacc  TOOLDIR=../bin
188  LEXPATH=$BINDIR/ml-lex  
189  BURGPATH=$BINDIR/ml-burg  #
190    # A temporary file for post-editing the pathconfig file...
191    #
192    PCEDITTMP=$INSTALLDIR/pcedittmp.$$
193    
194    #
195    # files to be deleted after we are done...
196    #
197    tmpfiles=""
198    tmpfiles="$tmpfiles $ROOT/preloads.standard"
199    tmpfiles="$tmpfiles $LIBLIST"
200    tmpfiles="$tmpfiles $LATESTANDALONES"
201    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
202    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
203    tmpfiles="$tmpfiles $PCEDITTMP"
204    #
205    # make sure we always clean up after ourselves...
206    #
207    trap 'rm -f $tmpfiles' 0 1 2 3 15
208    
209    
210  #  #
211  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
212  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
213  #  -M.Blume (5/1998)  # Especially important is CM_PATHCONFIG_DEFAULT.
214  #  #
215  CM_YACC_DEFAULT=$YACCPATH  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig
216  CM_LEX_DEFAULT=$LEXPATH  export CM_PATHCONFIG_DEFAULT
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATH_DEFAULT=.:$LIBDIR  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATH_DEFAULT  
217    
218  #  #
219  # the release version that we are installing  # the release version that we are installing
220  #  #
221  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
222  echo "installing version $VERSION"  vsay $this: Installing version $VERSION.
223    
224  #  #
225  # create the various sub directories  # the URL for the (usually remote) source archive
226  #  #
227  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
228  do  vsay $this: URL of source archive is $SRCARCHIVEURL.
229    if [ -d $dir ]; then  
230      echo "$dir already exists"  #
231    # Function to make a directory including its ancestors.
232    #
233    makedir() {
234        if [ x$1 = x ] ; then
235            :
236        elif [ -d $1 ] ; then
237            :
238    else    else
239      echo "creating $dir"          makedir `dirname $1`
240      mkdir $dir          if [ x${INSTALL_VERBOSE} = xtrue ] ; then
241      if [ $? != "0" ]; then              vsay "$this: Making directory $1"
242        echo "unable to create $dir"          fi
243        exit 1          if mkdir $1 ; then
244                :
245            else
246                complain "$this: !!! Unable to make directory $1!"
247      fi      fi
248    fi    fi
249    }
250    
251    #
252    # Function for asking user to fetch source archive.
253    #   $1 - descriptive name
254    #   $2 - base name without extension, without version, and without dir
255    #   $3 - remote directory
256    #
257    askurl() {
258        echo "$this: Please, fetch $1 archive"
259        echo ' ('$2.'*' or $VERSION-$2.'*)'
260        echo " from $3"
261        echo " and then re-run this script!"
262        exit 1
263    }
264    
265    #
266    # Function for fetching source archives automatically using wget or lynx.
267    #   $1 - command to actually get the stuff
268    #   $2 - descriptive name
269    #   $3 - base name without extension and without dir
270    #   $4 - remote directory
271    #
272    fetchurl() {
273        getter=$1 ; shift
274        vsay $this: Fetching $1 from $3. Please stand by...
275        fetched=no
276        for base in $2 $VERSION-$2 ; do
277            for ext in tar.gz tgz tar.Z tz tar tar.bz2 ; do
278                try=$base.$ext
279                vsay $this: Trying $try ...
280                if $getter $3/$try $ROOT/$try ; then
281                    fetched=yes
282                    vsay $this: Fetching $try was a success.
283                    break 2         # get out of both for-loops
284                else
285                    rm -f $ROOT/$try
286                fi
287            done
288  done  done
289        if [ $fetched = no ] ; then
290            echo $this: Fetching $try was no success.
291            echo '  ' You should try to do it manually now.
292            askurl "$1" "$2" "$3"
293        fi
294    }
295    
296    # wrapper for wget
297    usewget() {
298        wget -nv -O $2 $1
299    }
300    
301    # wrapper for lynx
302    uselynx() {
303        lynx -source $1 >$2
304    }
305    
306    # wrapper for curl
307    usecurl() {
308        curl -s $1 >$2
309    }
310    
311    testurlgetter() {
312        (exec >/dev/null 2>&1 ; exec $*)
313    }
314    
315    #
316    # Function to check whether wget or lynx is available.
317    # Set URLGETTER accordingly.  URLGETTER can be set externally
318    # to either 'wget' or 'curl' or 'lynx' -- in which case the
319    # corresponding command will be used (properly wrapped).  Any
320    # other external setting will be passed directly to fetchurl (without
321    # wrapping -- meaning it must take precisely two argumets: source and
322    # destination, in that order).
323    #
324    urlgetter() {
325        case ${URLGETTER:-unknown} in
326            fetchurl*)
327                ;;
328            unknown)
329                # automatically figure out which wrapper to use
330                if testurlgetter wget --help ; then
331                    URLGETTER="fetchurl usewget"
332                elif testurlgetter curl -s -O file:///dev/null -o /dev/null ; then
333                    URLGETTER="fetchurl usecurl"
334                elif testurlgetter lynx -help ; then
335                    URLGETTER="fetchurl uselynx"
336                else
337                    URLGETTER="askurl"
338                fi
339                ;;
340            wget|curl|lynx)
341                # special getters we know how to wrap
342                URLGETTER="fetchurl use${URLGETTER}"
343                ;;
344            *)
345                # other -- must be able to work without wrapper
346                URLGETTER="fetchurl ${URLGETTER}"
347                ;;
348        esac
349    }
350    
351    # wrapper for tar
352    un_tar() {
353        vsay "$this: Un-TAR-ing $1 archive."
354        tar -xf $2
355    }
356    
357    # wrapper for zcat followed by tar
358    un_tar_Z() {
359        vsay "$this: Un-COMPRESS-ing and un-TAR-ing $1 archive."
360        zcat $2 | tar -xf -
361    }
362    
363    # wrapper for gunzip followed by tar
364    un_tar_gz() {
365        vsay "$this: Un-GZIP-ing and un-TAR-ing $1 archive."
366        gunzip -c $2 | tar -xf -
367    }
368    
369    # wrapper for bunzip2 followed by tar
370    un_tar_bz2() {
371        vsay "$this: Un-BZIP2-ing and un-TAR-ing $1 archive."
372        bunzip2 -c $2 | tar -xf -
373    }
374    
375    # unarchive archive without and with version number attached
376    unarchive() {
377        # $1: descriptive string, $2: archive, $3: unpacker
378        if [ -r $ROOT/$2 ] ; then
379            $3 "$1" $ROOT/$2
380        elif [ -r $ROOT/$VERSION-$2 ]; then
381            $3 "$1" $ROOT/$VERSION-$2
382        else
383            return 1
384        fi
385    }
386    
387    #
388    # Function to unpack a source archive.
389    #
390    # $1: descriptive name of the sources to be unpacked
391    # $2: the directory into which to unpack the sources
392    # $3: the sub-directory of $2 that is going to be created by unpacking
393    # $4: the basename of the source archive (the script will check several
394    #     different suffixes to determine what kind of de-compression is to
395    #     be used)
396    #
397    # fetch_n_unpack is the helper function that does the real work.  If
398    # no archive is found locally, it invokes $URLGETTER and tries again.
399    # The variable $tryfetch is used to make sure this happens only once.
400    fetch_n_unpack() {
401        cd $2
402        if unarchive "$1" $4.tar.gz un_tar_gz ||
403           unarchive "$1" $4.tgz un_tar_gz ||
404           unarchive "$1" $4.tar.Z un_tar_Z ||
405           unarchive "$1" $4.tar un_tar ||
406           unarchive "$1" $4.tar.bz2 un_tar_bz2 ||
407           unarchive "$1" $4.tz un_tar_Z
408        then
409            : we are done
410        elif [ $tryfetch = yes ] ; then
411            urlgetter
412            $URLGETTER "$1" $4 $SRCARCHIVEURL
413            tryfetch=no
414            fetch_n_unpack "$1" "$2" "$3" "$4"
415        fi
416    }
417    
418    #
419    # The main "unpack" driver function that invokes the above helper.
420    #
421    unpack() {
422        tryfetch=yes
423        if [ -d $2/$3 ]; then
424            vsay "$this: The $1 tree already exists."
425        else
426            fetch_n_unpack "$1" "$2" "$3" "$4"
427        fi
428        if [ ! -d $2/$3 ]; then
429            complain "$this: !!! Unable to unpack $1 archive."
430        fi
431    }
432    
433    # A function to move all stable library files to a parallel directory
434    # hierarchy.
435    # The first argument must be a simple path (no / inside), and
436    # the second argument must be an absolute path.
437    move() {
438        if [ -d $1 ] ; then
439            if [ ! -d $2 ] ; then
440                if [ -f $2 ] ; then
441                    complain $this: $2 exists as a non-directory.
442                fi
443                mkdir $2
444            fi
445            cd $1
446            for i in * ; do
447                move $i $2/$i
448            done
449            cd ..
450        elif [ -f $1 ] ; then
451            rm -f $2
452            mv $1 $2
453        fi
454    }
455    
456    # move stable library file from $1 to $2
457    movelib()
458    {
459        SOURCE=$1
460        TARGET=$2
461        TARGETDIR=`dirname ${TARGET}`
462        if [ ! -d ${TARGETDIR} ] ; then
463            makedir ${TARGETDIR}
464        fi
465        mv ${SOURCE} ${TARGET}
466    }
467    
468    # A shell function that registers a library for being built.
469    # This function takes 3 arguments:
470    #   $1 = controlling anchor
471    #   $2 = name relative to controlling anchor
472    #   $3 = dir (relative to ${SRCDIR}) corresponding to $1
473    #
474    # This works by adding ML code to file $LIBLIST.  The code in this file
475    # will be executed near the end of this script.  If $MOVE_LIBRARIES is
476    # set to true, then reglib will also register a "movelib" to be executed at
477    # the end by putting a "movelib" line into $LIBMOVESCRIPT.
478    reglib() {
479        ANCHOR=$1
480        RELNAME=$2
481        LIBNAME='$'${ANCHOR}/${RELNAME}
482        ADIR=${SRCDIR}/$3
483        RELDIR=`dirname $RELNAME`
484        RELBASE=`basename $RELNAME`
485        if [ x$RELDIR = x. ] ; then
486            RELDIR=
487        else
488            RELDIR=/$RELDIR
489        fi
490        RELLOC=${RELDIR}/CM/${ARCH}-unix/${RELBASE}
491        SRCFINALLOC=${ADIR}${RELLOC}
492        if [ x$MOVE_LIBRARIES = xtrue ] ; then
493            FINALLOC=${LIBDIR}/${ANCHOR}${RELLOC}
494            FINALCONFIGPATH=${ANCHOR}
495        else
496            FINALLOC=${SRCFINALLOC}
497            FINALCONFIGPATH=${ADIR}
498        fi
499    
500        if [ -f ${FINALLOC} ] ; then
501            vsay "$this: Library ${LIBNAME} already exists in ${FINALLOC}"
502        else
503            vsay "$this: Scheduling library ${LIBNAME} to be built as ${FINALLOC}."
504            echo "  andalso CM.stabilize false \"${LIBNAME}\"" >>${LIBLIST}
505            echo ${ANCHOR} ${ADIR} >>${LOCALPATHCONFIG}
506            if [ x$MOVE_LIBRARIES = xtrue ] ; then
507                echo movelib ${SRCFINALLOC} ${FINALLOC} >>${LIBMOVESCRIPT}
508            fi
509        fi
510        echo ${ANCHOR} ${FINALCONFIGPATH} >>${CM_PATHCONFIG_DEFAULT}
511    }
512    
513    #
514    # Function to build a standalone program such as ml-yacc.  The function takes
515    # 2 or 3 or 4 arguments.  First the name of the program which at the same time
516    # is the directory name under $SRCDIR/$4 where the sources reside.  The second
517    # argument is a descriptive name for the program (passed on to "unpack").
518    # The optional third argument specifies the path relative to $SRCDIR/$4/$1
519    # of the directory where the program's heap image is to be found.
520    # The fourth argument, if missing, defaults to "."
521    #
522    
523    standalone() {
524        TARGET=$1.$HEAP_SUFFIX
525        if [ $# = 3 ] ; then
526            TARGETLOC=$3/$TARGET
527        else
528            TARGETLOC=$TARGET
529        fi
530        if [ $# = 4 ] ; then
531             MYSRCDIR=$SRCDIR/$4
532        else
533             MYSRCDIR=$SRCDIR
534        fi
535        if [ -r $HEAPDIR/$TARGET ] ; then
536            vsay $this: Target $TARGET already exists.
537        else
538            echo $this: Building $TARGET.
539            unpack $2 $MYSRCDIR $1 $1
540            cd $MYSRCDIR/$1
541            # build it, but make sure we don't pick up some (unrelated)
542            # local path configuration...
543            CM_LOCAL_PATHCONFIG=/dev/null ./build
544            if [ -r $TARGETLOC ] ; then
545                mv $TARGETLOC $HEAPDIR/$TARGET
546                if [ ! -f $BINDIR/$1 ] ; then
547                    cd $BINDIR
548                    ln -s .run-sml $1
549                fi
550            else
551                echo "$this: !!! Build of $TARGET failed."
552            fi
553        fi
554    }
555    
556    ######################################################################
557    
558    #
559    # create the various sub directories
560    #
561    for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
562        makedir $dir
563    done
564    
565  #  #
566  # install the script that tests the architecture, and make sure that it works  # install the script that tests the architecture, and make sure that it works
567  #  #
568  if [ -x $BINDIR/.arch-n-opsys ]; then  if [ -x $BINDIR/.arch-n-opsys ]; then
569    echo "$BINDIR/.arch-n-opsys already exists"      vsay $this: Script $BINDIR/.arch-n-opsys already exists.
570  else  else
571    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys      cat $CONFIGDIR/_arch-n-opsys \
572        | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys
573    chmod 555 $BINDIR/.arch-n-opsys    chmod 555 $BINDIR/.arch-n-opsys
574    if [ ! -x $BINDIR/.arch-n-opsys ]; then    if [ ! -x $BINDIR/.arch-n-opsys ]; then
575      echo "!!! installation of $BINDIR/.arch-n-opsys failed for some reason"          complain "$this: !!! Installation of $BINDIR/.arch-n-opsys failed."
     exit 1  
576    fi    fi
577  fi  fi
578    
579  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
580  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
581    echo "!!! $BINDIR/.arch-n-opsys fails on this machine"      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
582    echo "!!! you must patch this by hand and repeat the installation"      echo "$this: !!! You must patch this by hand and repeat the installation."
583    exit 2    exit 2
584  else  else
585    echo "$BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS"      vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
586  fi  fi
587  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
588    
589  if [ -x $BINDIR/.run-sml ]; then  #
590    echo "$BINDIR/.run-sml already exists"  # Function to install a "driver" script...
591  else  #   This takes care of patching the source of the script with the SHELL,
592    cat $CONFIGDIR/_run-sml | \  #   BINDIR, and VERSION variables to use.
593      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  #
594      > $BINDIR/.run-sml  installdriver() {
595    chmod 555 $BINDIR/.run-sml      dsrc=$1
596    if [ ! -x $BINDIR/.run-sml ]; then      ddst=$2
597      echo "!!! installation of $BINDIR/.run-sml failed for some reason"  # We install the driver unconditionally. (It would be better to test
598      exit 1  # for an outdated driver script, but not all "test" commands understand
599    fi  # the -nt comparison operator....)
600    #   if [ -x $BINDIR/$ddst ]; then
601    #       echo $this: Script $BINDIR/$ddst already exists.
602    #   else
603            rm -f $BINDIR/$ddst
604            cat $CONFIGDIR/$dsrc | \
605            sed -e "s,@SHELL@,$SHELL,g" \
606                -e "s,@BINDIR@,$BINDIR," \
607                -e "s,@VERSION@,$VERSION," \
608                > $BINDIR/$ddst
609            chmod 555 $BINDIR/$ddst
610            if [ ! -x $BINDIR/$ddst ]; then
611                complain "$this: !!! Installation of $BINDIR/${ddst} failed."
612  fi  fi
613    #   fi
614    }
615    
616    installdriver _run-sml .run-sml
617    installdriver _link-sml .link-sml
618    installdriver _ml-build ml-build
619    installdriver _ml-makedepend ml-makedepend
620    
621  #  #
622  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
623  #  #
624  case $ARCH in  case $ARCH in
625    mips*) ALLOC=1M ;;      mips*)
626            ALLOC=1M
627            ;;
628    x86)    x86)
629            # The following is the _wrong_ value for many popular x86 chips
630            # (i.e., Celerons).  However, the optimal value for those is 32k,
631            # and such a small value is not enough for the runtime system's boot
632            # code.  Therefore, we use 256k here and re-set it to the proper
633            # value in .run-sml.
634      ALLOC=256k      ALLOC=256k
635    ;;    ;;
636    alpha32)    alpha32)
# Line 155  Line 640 
640      ALLOC=512k      ALLOC=512k
641    ;;    ;;
642  esac  esac
643    
644  case $OPSYS in  case $OPSYS in
645    solaris)    solaris)
646      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 162  Line 648 
648    linux)    linux)
649      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
650      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
651        echo "problems checking for underscores in global names"              complain "$this: !!! Problems checking for underscores in asm names."
       exit 1  
652      fi      fi
653      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
654    ;;    ;;
# Line 172  Line 657 
657  #  #
658  # the name of the bin files directory  # the name of the bin files directory
659  #  #
660  BIN_FILES=bin.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
661    BOOT_FILES=sml.$BOOT_ARCHIVE
662    
663  #  #
664  # build the run-time system  # build the run-time system
665  #  #
666  $CONFIGDIR/unpack.sh "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime.tar  unpack "run-time" $SRCDIR runtime runtime
667  if [ "$?" != "0" ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
668    exit $?      vsay $this: Run-time system already exists.
669  fi  else
 if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  
670    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
671    echo "compiling the run-time system"      echo $this: Compiling the run-time system.
672    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
673    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
674      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
675      $MAKE MAKE=$MAKE clean      $MAKE MAKE=$MAKE clean
676    else    else
677      echo "!!! run-time system build failed for some reason"          complain "$this: !!! Run-time system build failed for some reason."
     exit 1  
678    fi    fi
679  fi  fi
680  cd $SRCDIR  cd $SRCDIR
# Line 199  Line 683 
683  # boot the base SML system  # boot the base SML system
684  #  #
685  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
686    echo "$HEAPDIR/sml.$HEAP_SUFFIX already exists"      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
687  else  else
688    $CONFIGDIR/unpack.sh bin $ROOT $BIN_FILES $ROOT/$VERSION-$BIN_FILES.tar      unpack bin $ROOT $BOOT_FILES $BOOT_ARCHIVE
689        cd $ROOT/$BOOT_FILES
690        if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
691        then
692    cd $ROOT    cd $ROOT
   $RUNDIR/run.$ARCH-$OPSYS @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
     $SET_FLAGS  
     val use = Compiler.Interact.useFile  
     val _ = (SMLofNJ.exportML "sml";  
              print Compiler.banner;  
              print "\n");  
 XXXX  
693    if [ -r sml.$HEAP_SUFFIX ]; then    if [ -r sml.$HEAP_SUFFIX ]; then
694      mv sml.$HEAP_SUFFIX $HEAPDIR      mv sml.$HEAP_SUFFIX $HEAPDIR
695      cd $BINDIR      cd $BINDIR
696      ln -s .run-sml sml      ln -s .run-sml sml
697                #
698                # Now move all stable libraries to #LIBDIR and generate
699                # the pathconfig file.
700                #
701                cd $ROOT/$BOOT_FILES
702                for anchor in * ; do
703                    if [ -d $anchor ] ; then
704                        echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT
705                        move $anchor $LIBDIR/$anchor
706                    fi
707                done
708                cd $ROOT
709                # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
710                rm -rf $BOOT_FILES
711    
712    else    else
713      echo "!!! unable to build SML heap image (sml.$HEAP_SUFFIX)"              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
714      exit 1          fi
715        else
716            complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
717    fi    fi
718  fi  fi
719    
720    #
721    # Initialize $LIBLIST
722    #
723    cd $ROOT
724    rm -f $LOCALPATHCONFIG $LIBLIST
725    echo 'ignore (OS.Process.exit (if true' >$LIBLIST
726    
727  #  #
728  # now build the individual targets  # now build (or prepare to build) the individual targets
729  #  #
730  cd $SRCDIR  cd $SRCDIR
731  echo "install targets"  vsay $this: Installing other targets.
732  for i in $TARGETS  for i in $TARGETS ; do
 do  
   if [ $i = "doc" ]; then  
     TARGET=$i  
   else  
     TARGET=$i.$HEAP_SUFFIX  
   fi  
   if [ -r $HEAPDIR/$TARGET ]; then  
     echo "$TARGET already exists"  
   else  
     echo "  building $TARGET"  
733      case $i in      case $i in
734        src-smlnj)        src-smlnj)
735          for src in compiler comp-lib cm MLRISC; do          for src in compiler cm MLRISC smlnj-lib ml-yacc system
736            $CONFIGDIR/unpack.sh $src $ROOT/src $src $ROOT/$VERSION-$src.tar          do
737                unpack $src $ROOT/src $src $src
738          done          done
739        ;;        ;;
       sml-full)  
         if [ ! -d $ROOT/$BIN_FILES ]; then  
           echo "!!! bin files are missing; build of $TARGET failed"  
           exit 1  
         else  
           cd $ROOT  
           $RUNDIR/run.$ARCH-$OPSYS @SMLfull @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
             $SET_FLAGS  
             val use = Compiler.Interact.useFile  
             val _ = (SMLofNJ.exportML "sml-full";  
                      print Compiler.banner;  
                      print " [full]\n");  
 XXXX  
           if [ -r sml-full.$HEAP_SUFFIX ]; then  
             mv sml-full.$HEAP_SUFFIX $HEAPDIR  
             cd $BINDIR  
             ln -s .run-sml sml-full  
           else  
             echo "!!! unable to build SML-FULL heap image"  
             exit 1  
           fi  
         fi  
       ;;  
740        ml-yacc)        ml-yacc)
741          $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar          standalone ml-yacc ML-Yacc src
742          if [ "$?" != "0" ]; then          echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc  
         ./build  
         if [ -r src/$TARGET ]; then  
           mv src/$TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
743        ;;        ;;
744        ml-lex)        ml-lex)
745          $CONFIGDIR/unpack.sh ML-Lex $SRCDIR ml-lex $ROOT/$VERSION-ml-lex.tar          standalone ml-lex ML-Lex
746          if [ "$?" != "0" ]; then          echo ml-lex $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
           exit $?  
         fi  
         cd $SRCDIR/ml-lex  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
747        ;;        ;;
748        ml-burg)        ml-burg)
749          $CONFIGDIR/unpack.sh ML-Burg $SRCDIR ml-burg $ROOT/$VERSION-ml-burg.tar          standalone ml-burg ML-Burg
750          if [ "$?" != "0" ]; then          echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
751            exit $?          ;;
752          fi        ml-nlffigen)
753          cd $SRCDIR/ml-burg          echo standalone ml-nlffigen ML-NLFFI-Gen >>$LATESTANDALONES
754          ./build          echo ml-nlffigen $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
755        ;;        ;;
756        smlnj-lib)        smlnj-lib)
757          $CONFIGDIR/unpack.sh "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib.tar          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
758          if [ "$?" != "0" ]; then  
759            exit $?          # Don't make the Util library -- it came pre-made and has been
760          fi          # installed when making the base system.  In other words, don't do...
761        # make the Util library              #reglib smlnj-lib.cm smlnj-lib.cm smlnj-lib/Util
762          cd $SRCDIR/smlnj-lib/Util          # ... and don't make the HTML library ...
763          echo "$CM_MAKE_LIB" | $BINDIR/sml              #reglib html-lib.cm html-lib.cm smlnj-lib/HTML
764          if [ ! -f $LIBDIR/smlnj-lib.cm ]; then          # ... and don't make the PP library ...
765            cd $LIBDIR              #reglib pp-lib.cm pp-lib.cm smlnj-lib/PP
           echo "Alias $SRCDIR/smlnj-lib/Util/sources.cm" > smlnj-lib.cm  
         fi  
766        # make the Unix library        # make the Unix library
767          cd $SRCDIR/smlnj-lib/Unix              reglib unix-lib.cm unix-lib.cm smlnj-lib/Unix
768          echo "$CM_MAKE_LIB" | $BINDIR/sml          # make the INet library
769          if [ ! -f $LIBDIR/unix-lib.cm ]; then              reglib inet-lib.cm inet-lib.cm smlnj-lib/INet
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Unix/sources.cm" > unix-lib.cm  
         fi  
       # make the HTML library  
         cd $SRCDIR/smlnj-lib/HTML  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/html-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/HTML/sources.cm" > html-lib.cm  
         fi  
       # make the Reactive library  
         cd $SRCDIR/smlnj-lib/Reactive  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/reactive-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Reactive/sources.cm" > reactive-lib.cm  
         fi  
       # make the PP library  
         cd $SRCDIR/smlnj-lib/PP  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/pp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/PP/sources.cm" > pp-lib.cm  
         fi  
770        # make the RegExp library        # make the RegExp library
771          cd $SRCDIR/smlnj-lib/RegExp              reglib regexp-lib.cm regexp-lib.cm smlnj-lib/RegExp
772          echo "$CM_MAKE_LIB" | $BINDIR/sml          # make the Reactive library
773          if [ ! -f $LIBDIR/regexp-lib.cm ]; then              reglib reactive-lib.cm reactive-lib.cm smlnj-lib/Reactive
774            cd $LIBDIR          # make the HashCons library
775            echo "Alias $SRCDIR/smlnj-lib/RegExp/sources.cm" > regexp-lib.cm              reglib hash-cons-lib.cm hash-cons-lib.cm smlnj-lib/HashCons
         fi  
       ;;  
       ml-yacc-lib)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc/lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/ml-yacc-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/ml-yacc/lib/sources.cm" > ml-yacc-lib.cm  
         fi  
776        ;;        ;;
777        cml)        cml)
778          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
779          if [ "$?" != "0" ]; then          reglib cml core-cml.cm cml/src
780            exit $?          reglib cml cml-internal.cm cml/src
781          fi          reglib cml cml.cm cml/src
782          cd $SRCDIR/cml/src          reglib cml basis.cm cml/src
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/src/sources.cm" > cml.cm  
         fi  
783        ;;        ;;
784        cml-lib)        cml-lib)
785          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
786          if [ "$?" != "0" ]; then          reglib cml-lib trace-cml.cm cml/cml-lib/cm
787            exit $?          reglib cml-lib smlnj-lib.cm cml/cml-lib/cm
         fi  
         cd $SRCDIR/cml/cml-lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/cml-lib/sources.cm" > cml-lib.cm  
         fi  
       ;;  
       cml-cm)  
         CMD="CM.autoloading(SOME true); CM.clearAutoList();"  
         CMD="$CMD CM.autoload'(\"$LIBDIR/cml.cm\");"  
         if [ "$AUTOLOAD_CML_LIB" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/cml-lib.cm\");"  
         fi  
         if [ "$AUTOLOAD_EXENE" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/eXene.cm\");"  
         fi  
         cd $ROOT  
         $BINDIR/sml <<XXXX  
           $CMD  
           val _ = (SMLofNJ.exportML "$i";  
                 print CML.banner;  
                 print "[CML autoload]\n");  
 XXXX  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! unable to build autoloading CML"  
           exit 1  
         fi  
788        ;;        ;;
789        eXene)        eXene)
790          $CONFIGDIR/unpack.sh EXene $SRCDIR eXene $ROOT/$VERSION-eXene.tar          unpack EXene $SRCDIR eXene eXene
791          if [ "$?" != "0" ]; then          reglib eXene.cm eXene.cm eXene
792            exit $?          ;;
793          fi        ckit)
794          cd $SRCDIR/eXene          unpack "C-Kit" $ROOT ckit ckit
795          echo "$CM_MAKE_LIB" | $BINDIR/sml          reglib ckit-lib.cm ckit-lib.cm ../ckit/src
796          if [ ! -f $LIBDIR/eXene.cm ]; then          ;;
797            cd $LIBDIR        ml-nlffi-lib)
798            echo "Alias $SRCDIR/eXene/sources.cm" > eXene.cm          unpack "NLFFI Library" $SRCDIR ml-nlffi-lib ml-nlffi-lib
799          fi          reglib c memory/memory.cm ml-nlffi-lib
800            reglib c internals/c-int.cm ml-nlffi-lib
801            reglib c c.cm ml-nlffi-lib
802            ;;
803          pgraph-util)
804            unpack "CM source code" $SRCDIR cm cm
805            reglib pgraph-util.cm pgraph-util.cm cm/pgraph
806            ;;
807          mlrisc-tools)
808            unpack "MLRISC Tools Library" $SRCDIR MLRISC MLRISC
809            reglib mlrisc-tools pp.cm MLRISC/Tools
810            reglib mlrisc-tools source-map.cm MLRISC/Tools
811            reglib mlrisc-tools sml-ast.cm MLRISC/Tools
812            reglib mlrisc-tools prec-parser.cm MLRISC/Tools
813            reglib mlrisc-tools parser.cm MLRISC/Tools
814            reglib mlrisc-tools match-compiler.cm MLRISC/Tools
815            ;;
816          nowhere)
817            unpack "MLRISC Tools Library" $SRCDIR MLRISC MLRISC
818            echo standalone nowhere NoWhere . MLRISC/Tools >>$LATESTANDALONES
819            echo nowhere $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
820        ;;        ;;
821        doc)        doc)
822          $CONFIGDIR/unpack.sh Doc $ROOT doc $ROOT/$VERSION-doc.tar          echo Package doc is currently unavailable.
823          if [ "$?" != "0" ]; then          # unpack Doc $ROOT doc doc
824            exit $?          # cd $ROOT/doc
825          fi          # build $ROOT
         cd $ROOT/doc  
         build $ROOT  
826        ;;        ;;
827        *)        *)
828          echo "!!! unknown target $i"          echo "$this: !!! Unknown target $i."
829        ;;        ;;
830      esac      esac
   fi  
831  done  done
832    
833  if [ "$ENABLE_AUTOLOADING" = "TRUE" ]; then  #
834    CMD="CM.autoloading(SOME true); CM.clearAutoList();"  # Now go and stabilize all registered libraries...
835    if [ "$AUTOLOAD_SMLNJ_LIB" = "TRUE" ]; then  # This is done with library sources in their original locations inside
836      CMD="$CMD CM.autoload'(\"$LIBDIR/smlnj-lib.cm\");"  # $SRCDIR, so we must consult $LOCALPATHCONFIG.
837    fi  #
838    if [ "$AUTOLOAD_SMLNJ_UNIX" = "TRUE" ]; then  
839      CMD="$CMD CM.autoload'(\"$LIBDIR/unix-lib.cm\");"  echo $this: Compiling library code.
840    fi  echo 'then OS.Process.success else OS.Process.failure));' >>$LIBLIST
841    if [ "$AUTOLOAD_SMLNJ_HTML" = "TRUE" ]; then  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then
842      CMD="$CMD CM.autoload'(\"$LIBDIR/html-lib.cm\");"      vsay $this: Libraries compiled successfully.
843    fi  else
844    if [ "$AUTOLOAD_SMLNJ_REACTIVE" = "TRUE" ]; then      complain "$this: !!! Something went wrong when compiling the libraries."
     CMD="$CMD CM.autoload'(\"$LIBDIR/reactive-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_PP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/pp-lib.cm\");"  
845    fi    fi
846    if [ "AUTOLOAD_SMLNJ_REGEXP" = "TRUE" ]; then  
847      CMD="$CMD CM.autoload'(\"$LIBDIR/regexp-lib.cm\");"  #
848    # Move the libraries to their final locations...
849    #
850    
851    if [ -r $LIBMOVESCRIPT ] ; then
852        vsay $this: Moving libraries to $LIBDIR.
853        . $LIBMOVESCRIPT
854    fi    fi
855    cd $ROOT  
856    $BINDIR/sml <<XXXX  #
857      $CMD  # Build "late" standalone programs (i.e., those that must be built
858      val _ = (SMLofNJ.exportML "sml";  # after libraries are already in place):
859               print Compiler.banner;  #
860               print " [CM; autoload enabled]\n");  
861  XXXX  if [ -r $LATESTANDALONES ] ; then
862    if [ -r sml.$HEAP_SUFFIX ]; then      vsay $this: Building late standalone programs.
863      mv sml.$HEAP_SUFFIX $HEAPDIR      . $LATESTANDALONES
   else  
     echo "!!! unable to build SML with autoloading"  
     exit 1  
864    fi    fi
865    
866    #
867    # Finally, remove duplicate entries from pathconfig file...
868    #
869    if [ -f $CM_PATHCONFIG_DEFAULT ] ; then
870        cp $CM_PATHCONFIG_DEFAULT $PCEDITTMP
871        rm -f $CM_PATHCONFIG_DEFAULT
872        awk <$PCEDITTMP 'NF == 2 { mapping[$1] = $2 }
873    NF != 2 { print $0 }
874    END { for (i in mapping) print i, mapping[i] }' \
875          | sort >$CM_PATHCONFIG_DEFAULT
876  fi  fi
877    
878    exit 0

Legend:
Removed from v.249  
changed lines
  Added in v.1140

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0